mui.plusReady(function () {
    var $ = mui;

//  //设置 badge end
    var tpl = '<div class="row-2 mui-table-view-cell mui-row mui-transitioning" data-id="{{id}}">\
                <div class="mui-slider-right mui-disabled">\
                    <a class="mui-btn mui-btn-red my-btn" data-btn="delete">删除</a>\
                </div>\
                <div class="mui-slider-handle my-btn" data-btn="msg">\
                    <div class="avatar fl" style="background-image: url({{picture}})"><span class="{{read}}"></span></div>\
                    <div class="info fr">\
                        <h4>{{name}}<span class="fr">&nbsp;</span></h4>\
                        <div class="mui-ellipsis">{{content}}</div>\
                    </div>\
                </div>\
            </div>';
     var parse = function (arr) {
        var str = '';
        for (var key = 0, len = arr.length; key < len; key++) {
            var item = arr [key];
            item.read == 0?item.read ="mui-badge":item.read ="";
            if (typeof item == 'object') {
                str += tpl.replace('{{id}}', item.id)
                    .replace('{{name}}', item.name)
                    .replace('{{picture}}', item.picture)
                    .replace('{{content}}', item.content)
                    .replace('{{read}}',item.read)
                    .replace('{{time}}', item.time);
            }

        }
        return str;
    };
    var action = "up", context;
    // 延时更新内容渲染，避免争夺系统资源，低配置的设备可以更快速的显示
    setTimeout(function () {
        $.init({swipeBack: false});
        var list = [];
        var content = document.getElementById("list");
        $('#pullrefresh').$$pullRefresh({
            "down": {
                "contentnomore": '没有更多的消息',
                "callback": function () {
                    action = "down";
                    var self = this;
                    context = self;
                    getMsgList(context, action, function (data) {
                        content.innerHTML = parse(data);
                        self.refresh();
                        self.endPulldownToRefresh();
                    });
                }
            },
            "up": {
                "auto": true,
                "offset": 300,
                "show": true,
                "contentnomore": '没有更多的消息',
                callback: function () {
                    var self = this;
                    action = "up";
                    context = self;
                    getMsgList(context, action, function (data) {
                        content.innerHTML = parse(data);
                        self.refresh();
                        self.endPullupToRefresh(true);
                    });
                }
            }
        });

         function getMsgList(context, action, callback) {
            app.post('Message/get_list', {"type": 1}).then(function (data) {
                console.log(JSON.stringify(data));
                list = data;
                callback(data);
            }, function () {
                context.refresh();
                switch (action) {
                    case "up":
                        context.endPullupToRefresh(true);
                        break;
                    case "down":
                        context.endPulldownToRefresh();
                        break;
                }
                //请求失败页面显示的内容
                content.innerHTML = '<p class="tc" style="padding-top: 45px;">请求网络失败，下拉可刷新<p>';
            });
        }

        //数据已完结时
        function isEnd() {
            context.refresh();
            context.endPullupToRefresh(true);
            context.endPullupToRefresh(true);
        }

        $(document).on('tap', '.my-btn', function () {
            var btn = this.dataset.btn;
            var el = this;
            var li;
            switch (btn) {
                case "href":
                    var href = this.dataset.href;
                    $.openWindow({
                        "url": href,
                        "id": href,
                        "styles": {"bounce": "none", "scrollIndicator": 'none'},
                        "waiting": {"autoShow": false}
                    });
                    break;
                case "msg":
                    li = el.parentNode;
                    var item = getItem(list, li.dataset.id);
                    mui(".avatar")[0].querySelector("span").classList.remove("mui-badge");
                    $.fire(plus.webview.getLaunchWebview(), "openMsgView", {"msgId": item.id, "titleText": item.name,"read":item.read});
                    break;
                case "delete":
                    app.confirm('确认删除该条记录？', '重运宝', ["取消", "确定"], function (e) {
                        li = el.parentNode.parentNode;
                        if (e.index == 1) {
                            var item = getItem(list, li.dataset.id);
                            app.post('Message/del', {"id": item.id}).then(function () {
                            	mui.toast("删除成功");
                            });
                            li.parentNode.removeChild(li);
                        } else {
                            setTimeout(function () {
                                $.swipeoutClose(li);
                            }, 0);
                        }
                    });
                    break;
            }
        });

    }, 150);

    function getItem(list, id) {
        var item;
        for (var key in list) {
            var val = list[key];
            if (val && val.id == id) {
                item = val;
                return item;
            }
        }
        return item;
    }

});
