/**
 * Created by Administrator on 2016/11/22.
 */
/***
 * store为localStorage的简化应用插件
 * 调用方法 store.get(key),store.set(key,value),store.remove(key);
 */

(function (store, mui) {
    "use strict";
    store.disabled = false;
    store.has = function (key) {
        return store.get(key) !== undefined
    };
    store.transact = function (key, defaultVal, transactionFn) {
        if (transactionFn == null) {
            transactionFn = defaultVal;
            defaultVal = null;
        }
        if (defaultVal == null) {
            defaultVal = {}
        }
        var val = store.get(key, defaultVal);
        transactionFn(val);
        store.set(key, val);
    };
    store.getAll = function () {
        var ret = {};
        store.forEach(function (key, val) {
            ret[key] = val;
        });
        return ret;
    };
    store.serialize = function (value) {
        return JSON.stringify(value);
    };
    store.deserialize = function (value) {
        if (typeof value != 'string') {
            return undefined
        }
        try {
            return JSON.parse(value)
        }
        catch (e) {
            return value || undefined
        }
    };
    store.set = function (key, val) {
        if (val === undefined) {
            return store.remove(key)
        }
        plus.storage.setItem(key, store.serialize(val));
        return val;
    };
    store.setItem = store.set;
    store.get = function (key, defaultVal) {
        var val = store.deserialize(plus.storage.getItem(key));
        return (val === undefined ? defaultVal : val);
    };
    store.getItem= store.get;
    store.remove = function (key) {
        plus.storage.removeItem(key)
    };
    store.removeItem = store.remove;
    store.clear = function () {
        plus.storage.clear();
    };
    store.forEach = function (callback) {
        var numKeys = plus.storage.getLength();
        for (var i = 0; i < numKeys; i++) {
            var key = plus.storage.key(i);
            callback(key, store.get(key))
        }
    };
    // 数据同步。
    store.sync = function (Boolean) {
    };

})(window.store = {});